#
# Conditional build:
%bcond_without	python		# Python bindings for libbtrfsutil
%bcond_without	static_libs	# static libraries
%bcond_without	tests		# libbtrfsutil tests (requires python)

%if %{without python}
%undefine	with_tests
%endif
Summary:	Utilities belonging to the btrfs filesystem
Summary(pl.UTF-8):	Narzędzia należące do systemu plików btrfs
Name:		btrfs-progs
Version:	6.15
Release:	1
License:	GPL v2
Group:		Applications/System
Source0:	https://www.kernel.org/pub/linux/kernel/people/kdave/btrfs-progs/%{name}-v%{version}.tar.xz
# Source0-md5:	5dafd751d7907f2fe0c448daf2eeb6a9
Patch0:		%{name}-sh.patch
URL:		https://btrfs.readthedocs.io
BuildRequires:	acl-devel
BuildRequires:	autoconf >= 2.60
BuildRequires:	autoconf-archive
BuildRequires:	automake
BuildRequires:	e2fsprogs-devel >= 1.42.0
BuildRequires:	gcc >= 6:4.7
BuildRequires:	libblkid-devel
BuildRequires:	libcom_err-devel
BuildRequires:	libuuid-devel
BuildRequires:	linux-libc-headers >= 7:5.9
BuildRequires:	lzo-devel >= 2
BuildRequires:	pkgconfig >= 1:0.9.0
%{?with_python:BuildRequires:	python3-devel >= 1:3.4}
%{?with_python:BuildRequires:	python3-setuptools}
BuildRequires:	python3-sphinx_rtd_theme
BuildRequires:	reiserfsprogs-devel >= 3.6.27
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.527
BuildRequires:	sphinx-pdg
BuildRequires:	tar >= 1:1.22
BuildRequires:	udev-devel >= 1:190
BuildRequires:	xz
BuildRequires:	zlib-devel
BuildRequires:	zstd-devel >= 1.0.0
Requires:	e2fsprogs-libs >= 1.42.0
Requires:	reiserfsprogs-libs >= 1:3.6.27
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
Btrfs is a new copy on write filesystem for Linux aimed at
implementing advanced features while focusing on fault tolerance,
repair and easy administration.

%description -l pl.UTF-8
Btrfs to nowy system plików dla Linuksa oparty na zasadzie kopiowania
przy zapisie (copy-on-write), którego celem jest zaimplementowanie
zaawansowanych możliwości ze szczególnym naciskiem na odporność na
awarie, naprawę i łatwe administrowanie.

%package libs
Summary:	Shared btrfs library
Summary(pl.UTF-8):	Biblioteka współdzielona btrfs
Group:		Libraries

%description libs
Shared btrfs library.

%description libs -l pl.UTF-8
Biblioteka współdzielona btrfs.

%package devel
Summary:	Header files for btrfs filesystem-specific library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki dla systemu plików btrfs
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
This package contains the header files needed to develop btrfs
filesystem-specific programs.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe potrzebne przy tworzeniu programów
przeznaczonych dla systemu plików btrfs.

%package static
Summary:	Static btrfs filesystem library
Summary(pl.UTF-8):	Statyczna biblioteka dla systemu plików btrfs
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static btrfs filesystem library.

%description static -l pl.UTF-8
Statyczna biblioteka dla systemu plików btrfs.

%package -n libbtrfsutil
Summary:	Library for managing Btrfs filesystems
Summary(pl.UTF-8):	Biblioteka do zarządzania systemami plików Btrfs
License:	LGPL v2.1+
Group:		Libraries

%description -n libbtrfsutil
libbtrfsutil is a library for managing Btrfs filesystems. It is
licensed under the LGPL. libbtrfsutil provides interfaces for a subset
of the operations offered by the btrfs command line utility. It also
has official Python bindings (Python 3 only).

%description -n libbtrfsutil -l pl.UTF-8
libbtrfsutil to biblioteka do zarządzania systemami plików Btrfs. Jest
dostępna na licencji LGPL. Udostępnia interfejsy do podzbioru operacji
oferowanych przez narzędzie linii poleceń btrfs. Ma także oficjalne
wiązania do Pythona (tylko Pythona 3).

%package -n libbtrfsutil-devel
Summary:	Header file for libbtrfsutil library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki libbtrfsutil
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	libbtrfsutil = %{version}-%{release}

%description -n libbtrfsutil-devel
Header file for libbtrfsutil library.

%description -n libbtrfsutil-devel -l pl.UTF-8
Plik nagłówkowy biblioteki libbtrfsutil.

%package -n libbtrfsutil-static
Summary:	Static libbtrfsutil library
Summary(pl.UTF-8):	Statyczna biblioteka libbtrfsutil
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	libbtrfsutil-devel = %{version}-%{release}

%description -n libbtrfsutil-static
Static libbtrfsutil library.

%description -n libbtrfsutil-static -l pl.UTF-8
Statyczna biblioteka libbtrfsutil.

%package -n python3-btrfsutil
Summary:	Python library for managing Btrfs filesystems
Summary(pl.UTF-8):	Biblioteka Pythona do zarządzania systemami plików Btrfs
Group:		Libraries/Python
License:	LGPL v2.1+
Requires:	libbtrfsutil = %{version}-%{release}

%description -n python3-btrfsutil
Python library for managing Btrfs filesystems.

%description -n python3-btrfsutil -l pl.UTF-8
Biblioteka Pythona do zarządzania systemami plików Btrfs.

%prep
%setup -q -n %{name}-v%{version}
%patch -P0 -p1

%build
%{__aclocal} -I config
%{__autoconf}
%{__autoheader}
%configure \
	%{__enable_disable static_libs static} \
	%{!?with_python:--disable-python}
%{__make} \
	V=1

%if %{with tests}
%{__make} test-libbtrfsutil
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man8}
%{__make} install \
	prefix=%{_prefix} \
	bindir=%{_sbindir} \
	mandir=%{_mandir} \
	libdir=%{_libdir} \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with python}
%{__make} install_python \
	prefix=%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	-n libbtrfsutil -p /sbin/ldconfig
%postun	-n libbtrfsutil -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGES README.md
%attr(755,root,root) %{_sbindir}/btrfs
%attr(755,root,root) %{_sbindir}/btrfs-convert
%attr(755,root,root) %{_sbindir}/btrfs-find-root
%attr(755,root,root) %{_sbindir}/btrfs-image
%attr(755,root,root) %{_sbindir}/btrfs-map-logical
%attr(755,root,root) %{_sbindir}/btrfs-select-super
%attr(755,root,root) %{_sbindir}/btrfsck
%attr(755,root,root) %{_sbindir}/btrfstune
%attr(755,root,root) %{_sbindir}/fsck.btrfs
%attr(755,root,root) %{_sbindir}/mkfs.btrfs
/lib/udev/rules.d/64-btrfs-dm.rules
/lib/udev/rules.d/64-btrfs-zoned.rules
%{_mandir}/man5/btrfs.5*
%{_mandir}/man8/btrfs.8*
%{_mandir}/man8/btrfs-*.8*
%{_mandir}/man8/btrfsck.8*
%{_mandir}/man8/btrfstune.8*
%{_mandir}/man8/fsck.btrfs.8*
%{_mandir}/man8/mkfs.btrfs.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfs.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libbtrfs.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfs.so
%{_includedir}/btrfs
%{_mandir}/man2/btrfs-ioctl.2*

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libbtrfs.a
%endif

%files -n libbtrfsutil
%defattr(644,root,root,755)
%doc libbtrfsutil/README.md
%attr(755,root,root) %{_libdir}/libbtrfsutil.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libbtrfsutil.so.1

%files -n libbtrfsutil-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfsutil.so
%{_includedir}/btrfsutil.h
%{_pkgconfigdir}/libbtrfsutil.pc

%if %{with static_libs}
%files -n libbtrfsutil-static
%defattr(644,root,root,755)
%{_libdir}/libbtrfsutil.a
%endif

%if %{with python}
%files -n python3-btrfsutil
%attr(755,root,root) %{py3_sitedir}/btrfsutil.cpython-*.so
%{py3_sitedir}/btrfsutil-%{version}-py*.egg-info
%endif
%changelog
* Wed Jun 25 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/btrfs-progs.git;a=log;h=master

* Mon Jun 23 2025 Jan Palus <atler@pld-linux.org> dd6b62b
- up to 6.15

* Mon Jun 23 2025 Jan Palus <atler@pld-linux.org> 5bf8d3e
- BR: rpm-pythonprov

* Fri Apr 04 2025 Jan Palus <atler@pld-linux.org> 062e150
- up to 6.14

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> fdd3c54
- python 3.13 rebuild

* Sat Feb 15 2025 Jan Palus <atler@pld-linux.org> e6920a0
- up to 6.13

* Sat Feb 15 2025 Jan Palus <atler@pld-linux.org> 927500b
- use %patch -P

* Sat Nov 30 2024 Jan Palus <atler@pld-linux.org> 7afc5a3
- up to 6.12

* Thu Sep 19 2024 Jan Palus <atler@pld-linux.org> d802e8a
- up to 6.11

* Wed Jul 31 2024 Jan Palus <atler@pld-linux.org> 1fcabdd
- up to 6.10

* Thu Jun 27 2024 Jan Palus <atler@pld-linux.org> 5e634e6
- up to 6.9.2

* Tue Jun 25 2024 Jan Palus <atler@pld-linux.org> 4aab6e7
- up to 6.9.1

* Sun Jun 09 2024 Jan Palus <atler@pld-linux.org> c393032
- up to 6.9

* Thu May 02 2024 Jan Palus <atler@pld-linux.org> 1f8525e
- up to 6.8.1

* Tue Mar 26 2024 Jan Palus <atler@pld-linux.org> ac13ed0
- up to 6.8

* Wed Feb 14 2024 Jan Palus <atler@pld-linux.org> 1186c23
- up to 6.7.1

* Mon Jan 22 2024 Jan Palus <atler@pld-linux.org> e8f0776
- up to 6.7

* Thu Dec 14 2023 Jan Palus <atler@pld-linux.org> eb60015
- up to 6.6.3

* Wed Nov 15 2023 Jan Palus <atler@pld-linux.org> 0500849
- add static_libs bcond

* Wed Nov 15 2023 Jan Palus <atler@pld-linux.org> e037e7e
- up to 6.6.2

* Mon Nov 06 2023 Jan Palus <atler@pld-linux.org> 64c1cec
- up to 6.6.1

